package graphoutput;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import javax.media.j3d.*;
import javax.vecmath.*;
 
 /**
  * Extends the class Math with new functions depending on
  * Java3D
  */
public class MathExt
{

  /**
   * Calculates the normalized vector which is orthogonal to the triangle
   * specified by the three points x, a, and b.
   */
  public static Vector3f calcNormal(Point3d x, Point3d a, Point3d b)
  {
    Vector3d v1 = new Vector3d();
    Vector3d v2 = new Vector3d();
    v1.x = a.x - x.x;  v1.y = a.y - x.y;  v1.z = a.z - x.z;
    v2.x = b.x - x.x;  v2.y = b.y - x.y;  v2.z = b.z - x.z;
    v1.normalize();
    v2.normalize();
    Vector3d n = new Vector3d();
    n.cross(v1,v2);
    n.normalize();
    return (new Vector3f(n));
  }

}
